import sys

cdef extern from "Python.h":
    ctypedef struct PyModuleDef:
        const char* m_name;

    void Py_INCREF(object)
    object PyModule_FromDefAndSpec(PyModuleDef *definition, object spec)
    int PyModule_ExecDef(object module, PyModuleDef* definition)

cdef extern from "series.h":
    object PyInit_679603c9fcc61820fea77804d31af6ca8ef61884641e8c3d40d456df7ccf694e()
cdef extern from "chunks/base.h":
    object PyInit_956ec1c889e94114e1cdd5dc9c1d6338a34bfd7e4dfea63f0ce3f250abeeb663()
cdef extern from "chunks/maker.h":
    object PyInit_f16fd407cfbfb2ad452d52d2b745d1660ec3173e6bc8a2b02919498dbc99c5a7()
cdef extern from "chunks/normal.h":
    object PyInit_336fb6b6488526368c1e33543da3ca0cd859dbf09e2ec65a1e4a6e05351c65de()
cdef extern from "chunks/gzip.h":
    object PyInit_d98569182a9f3d1b03b4e628ab84218aee5e8d7f81bda7dd0dabe16fee5a83d0()
cdef extern from "chunks/direct.h":
    object PyInit_7e8c3d09a1c13dc99e4a4ac22f2fec9087991da8316365c6b6b626504e3e829a()
cdef extern from "metadata.h":
    object PyInit_52813ff72b14112a0b4a03ad67bce8e14752f5412dcf659ec80ae4653d42b095()
cdef extern from "exceptions.h":
    object PyInit_b3acacb50dcc31991db99af96cbbc49276820ec09dea463248e530ed3c8ade75()
cdef extern from "database.h":
    object PyInit_d669261a11c5ea9ef4aacea5a2cb2bea280f31edde418b3a912755c260d0612f()
cdef extern from "varlen.h":
    object PyInit_8f6eb1833faa2c0c5e75b3619be9a192fd2b492abfaf58ea5c14b28a36c9bd5b()
cdef extern from "iterators.h":
    object PyInit_3d4447dc7b7bb1110b2517eba53339464a96ffbe1d594577c18c821b6f80bff1()

cdef object get_definition_by_name(str name):
    if name == "tempsdb.series":
        return PyInit_679603c9fcc61820fea77804d31af6ca8ef61884641e8c3d40d456df7ccf694e()
    elif name == "tempsdb.chunks.base":
        return PyInit_956ec1c889e94114e1cdd5dc9c1d6338a34bfd7e4dfea63f0ce3f250abeeb663()
    elif name == "tempsdb.chunks.maker":
        return PyInit_f16fd407cfbfb2ad452d52d2b745d1660ec3173e6bc8a2b02919498dbc99c5a7()
    elif name == "tempsdb.chunks.normal":
        return PyInit_336fb6b6488526368c1e33543da3ca0cd859dbf09e2ec65a1e4a6e05351c65de()
    elif name == "tempsdb.chunks.gzip":
        return PyInit_d98569182a9f3d1b03b4e628ab84218aee5e8d7f81bda7dd0dabe16fee5a83d0()
    elif name == "tempsdb.chunks.direct":
        return PyInit_7e8c3d09a1c13dc99e4a4ac22f2fec9087991da8316365c6b6b626504e3e829a()
    elif name == "tempsdb.metadata":
        return PyInit_52813ff72b14112a0b4a03ad67bce8e14752f5412dcf659ec80ae4653d42b095()
    elif name == "tempsdb.exceptions":
        return PyInit_b3acacb50dcc31991db99af96cbbc49276820ec09dea463248e530ed3c8ade75()
    elif name == "tempsdb.database":
        return PyInit_d669261a11c5ea9ef4aacea5a2cb2bea280f31edde418b3a912755c260d0612f()
    elif name == "tempsdb.varlen":
        return PyInit_8f6eb1833faa2c0c5e75b3619be9a192fd2b492abfaf58ea5c14b28a36c9bd5b()
    elif name == "tempsdb.iterators":
        return PyInit_3d4447dc7b7bb1110b2517eba53339464a96ffbe1d594577c18c821b6f80bff1()


cdef class CythonPackageLoader:
    cdef PyModuleDef* definition
    cdef object def_o
    cdef str name

    def __init__(self, name):
        self.def_o = get_definition_by_name(name)
        self.definition = <PyModuleDef*>self.def_o
        self.name = name
        Py_INCREF(self.def_o)

    def load_module(self, fullname):
        raise ImportError

    def create_module(self, spec):
        if spec.name != self.name:
            raise ImportError()
        return PyModule_FromDefAndSpec(self.definition, spec)

    def exec_module(self, module):
        PyModule_ExecDef(module, self.definition)


class CythonPackageMetaPathFinder:
    def __init__(self, modules_set):
        self.modules_set = modules_set

    def find_module(self, fullname, path):
        if fullname not in self.modules_set:
            return None
        return CythonPackageLoader(fullname)

    def invalidate_caches(self):
        pass

def bootstrap_cython_submodules():
    modules_set = {'tempsdb.chunks.normal', 'tempsdb.exceptions', 'tempsdb.chunks.gzip', 'tempsdb.chunks.base', 'tempsdb.varlen', 'tempsdb.chunks.maker', 'tempsdb.series', 'tempsdb.database', 'tempsdb.iterators', 'tempsdb.chunks.direct', 'tempsdb.metadata'}
    sys.meta_path.append(CythonPackageMetaPathFinder(modules_set))
